package {
	import flash.events.Event;
	
	import mx.core.UIComponent;
	import mx.events.ResizeEvent;
	
	import org.papervision3d.cameras.Camera3D;
	import org.papervision3d.materials.ColorMaterial;
	import org.papervision3d.materials.WireframeMaterial;
	import org.papervision3d.materials.special.CompositeMaterial;
	import org.papervision3d.materials.utils.MaterialsList;
	import org.papervision3d.objects.primitives.Cube;
	import org.papervision3d.render.BasicRenderEngine;
	import org.papervision3d.scenes.Scene3D;
	import org.papervision3d.view.Viewport3D;

	public class RotateAroundCubeComponent extends UIComponent{
		private var viewport:Viewport3D;
		private var scene:Scene3D;
		private var camera:Camera3D;
		private var renderer:BasicRenderEngine;
		
		private var rotationX:Number=0;
		private var rotationY:Number=0;
		private var rotationZ:Number=0;
		
		private var randomizeRotationFrame:int=0;
		
		public function RotateAroundCubeComponent(){
			super();
			//init on 'added_to_stage' event so width and height are set properly
			this.addEventListener(Event.ADDED_TO_STAGE,init);
			//resize viewport when component resizes
			this.addEventListener(ResizeEvent.RESIZE,onResize);
		}
		
		private function init(event:Event):void{
			//setup papervision
			viewport=new Viewport3D(this.width,this.height);
			renderer=new BasicRenderEngine();
			scene=new Scene3D();
			camera=new Camera3D(60,10,2000,true);
			camera.zoom=100;
			camera.focus=10;
			this.addChild(viewport);
			//create cubes material
			var cubeMaterial:CompositeMaterial=new CompositeMaterial();
			var wireframeMaterial:WireframeMaterial=new WireframeMaterial(0x000000,1,1);
			var colorMaterial:ColorMaterial=new ColorMaterial(0xFFFFFF);
			cubeMaterial.addMaterial(wireframeMaterial);
			cubeMaterial.addMaterial(colorMaterial);
			var materialList:MaterialsList=new MaterialsList();
			materialList.addMaterial(cubeMaterial,"all");
			//create cubes
			var cube:Cube=new Cube(materialList,20,20,20);
			scene.addChild(cube);
			cube=new Cube(materialList,20,20,20);
			cube.x=-40;
			scene.addChild(cube);
			cube=new Cube(materialList,20,20,20);
			cube.x=40;
			scene.addChild(cube);
			cube=new Cube(materialList,20,20,20);
			cube.z=40;
			scene.addChild(cube);
			cube=new Cube(materialList,20,20,20);
			cube.z=-40;
			scene.addChild(cube);
			cube=new Cube(materialList,20,20,20);
			cube.y=40;
			scene.addChild(cube);
			cube=new Cube(materialList,20,20,20);
			cube.y=-40;
			scene.addChild(cube);
			//render on 'enter_frame' event
			this.addEventListener(Event.ENTER_FRAME,onEnterFrame);
		}
		
		private function onEnterFrame(event:Event):void{
			//randomize rotation value
			if(randomizeRotationFrame%200==0){
				rotationX=(Math.random()/2)-.25;
				rotationY=(Math.random())-.5;
				rotationZ=(Math.random()/8)-.0625;
			}
			randomizeRotationFrame++;
			//place camera
			camera.x=0;
			camera.y=0;
			camera.z=0;
			camera.rotationX+=rotationX;
			camera.rotationY+=rotationY;
			camera.rotationZ+=rotationZ;
			camera.moveBackward(1600);
			//render
			renderer.renderScene(scene,camera,viewport);
		}
		
		public function getCameraRotation():Object{
			if(camera!=null){
				return {x:camera.rotationX,y:camera.rotationY,z:camera.rotationZ};
			}
			return null;
		}
		
		private function onResize(event:ResizeEvent):void{
			if(viewport!=null){
				//resize viewport
				viewport.viewportWidth=this.width;
				viewport.viewportHeight=this.height
			}
		}
	}
}